# this package currently (2010-10-18) doesn`t build with ccuxbuild
# some final tests fail and I don`t know why - arcam

Distribution:	CCux
Packager:  	Christian Metzen <metzench@ccux-linux.de>

Summary: 	An ELF prelinking utility
Name: 		prelink
Version: 	0.4.3
Release: 	1
License: 	GPL
Group: 		System/Base
%define date 20100714
Source: 	ftp://people.redhat.com/jakub/prelink/prelink-%{date}.tar.bz2
Source2: 	prelink.conf
Source3: 	prelink.cron
Source4: 	prelink.sysconfig
Buildroot: 	%{_tmppath}/prelink-root
BuildArch:	i686
#BuildRequires: libelf-devel >= 0.7.0-5
BuildRequires: 	elfutils-libelf-devel-static
BuildRequires:  elfutils-devel
BuildRequires:  elfutils-libs
Requires:  	coreutils findutils
Requires: 	util-linux gawk grep

BuildRequires:	which

#Automatically resolved build dependencies
BuildRequires: elfutils-libelf-devel
BuildRequires: glibc-devel

%description
The prelink package contains a utility which modifies ELF shared libraries
and executables, so that far fewer relocations need to be resolved at runtime
and thus programs come up faster.

%prep
%setup -qn prelink

%build
sed -i -e '/^prelink_LDADD/s/$/ -lpthread/' src/Makefile.{am,in}
%configure --disable-shared
make %{_smp_mflags}
%define testcc CC='gcc -Wl,--add-needed,--disable-new-dtags' CXX='g++ -Wl,--add-needed,--disable-new-dtags'

echo ====================TESTING=========================
make -C testsuite check-harder %{testcc}
make -C testsuite check-cycle %{testcc}
echo ====================TESTING END=====================

echo "DEBUG"
dir testsuite/*.log
cat testsuite/*.log


%install
%{makeinstall}
mkdir -p %{buildroot}%{_sysconfdir}/rpm
cp -a %{SOURCE2} %{buildroot}%{_sysconfdir}
mkdir -p %{buildroot}%{_sysconfdir}/{sysconfig,cron.daily,prelink.conf.d}
cp -a %{SOURCE3} %{buildroot}%{_sysconfdir}/cron.daily/prelink
cp -a %{SOURCE4} %{buildroot}%{_sysconfdir}/sysconfig/prelink
chmod 755 %{buildroot}%{_sysconfdir}/cron.daily/prelink
chmod 644 %{buildroot}%{_sysconfdir}/{sysconfig/prelink,prelink.conf}
cat > %{buildroot}%{_sysconfdir}/rpm/macros.prelink <<"EOF"
# rpm-4.1 verifies prelinked libraries using a prelink undo helper.
#       Note: The 2nd token is used as argv[0] and "library" is a
#       placeholder that will be deleted and replaced with the appropriate
#       library file path.
%%__prelink_undo_cmd     /usr/sbin/prelink prelink -y library
EOF
chmod 644 %{buildroot}%{_sysconfdir}/rpm/macros.prelink

mkdir -p %{buildroot}/var/{lib/misc,log/prelink}
touch %{buildroot}/var/lib/misc/prelink.full
touch %{buildroot}/var/lib/misc/prelink.quick
touch %{buildroot}/var/lib/misc/prelink.force
touch %{buildroot}/var/log/prelink/prelink.log

%post
touch /var/lib/misc/prelink.force

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root)
%doc doc/prelink.pdf
%verify(not md5 size mtime) %config(noreplace) %{_sysconfdir}/prelink.conf
%verify(not md5 size mtime) %config(noreplace) %{_sysconfdir}/sysconfig/prelink
%{_sysconfdir}/rpm/macros.prelink
%dir %attr(0755,root,root) %{_sysconfdir}/prelink.conf.d
%{_sysconfdir}/cron.daily/prelink
%{_prefix}/sbin/prelink
%{_prefix}/bin/execstack
%{_mandir}/man8/prelink.8*
%{_mandir}/man8/execstack.8*
%attr(0644,root,root) %verify(not md5 size mtime) %ghost %config(missingok,noreplace) /var/lib/misc/prelink.full
%attr(0644,root,root) %verify(not md5 size mtime) %ghost %config(missingok,noreplace) /var/lib/misc/prelink.quick
%attr(0644,root,root) %verify(not md5 size mtime) %ghost %config(missingok,noreplace) /var/lib/misc/prelink.force
%dir /var/log/prelink
%attr(0644,root,root) %verify(not md5 size mtime) %ghost %config(missingok,noreplace) /var/log/prelink/prelink.log

%changelog
* Sun Oct 17 2010 Karsten Brockmann <arcam@ccux-linux.de> 0.4.3-1
- Version update
- 20100714 snapshot
* Thu Jan 24 2008 Christian Metzen <metzench@ccux-linux.de> 0.4.0-1
- Initial release
